use std::any::Any;

pub trait AsAny {
    fn as_any(&self) -> &dyn Any;
}

impl<T: Any> AsAny for T {
    fn as_any(&self) -> &dyn Any {
        self
    }
}

pub trait IntoWeak<T> {
    fn as_weak(self) -> std::rc::Weak<T>;
}

impl<T> IntoWeak<T> for std::rc::Rc<T> {
    fn as_weak(self) -> std::rc::Weak<T> {
        std::rc::Rc::downgrade(&self)
    }
}

impl<'a, T> IntoWeak<T> for &'a std::rc::Rc<T> {
    fn as_weak(self) -> std::rc::Weak<T> {
        std::rc::Rc::downgrade(&self)
    }
}

impl<T> IntoWeak<T> for std::rc::Weak<T> {
    fn as_weak(self) -> std::rc::Weak<T> {
        self
    }
}

impl<'a, T> IntoWeak<T> for &'a std::rc::Weak<T> {
    fn as_weak(self) -> std::rc::Weak<T> {
        self.clone()
    }
}

/*pub struct ClosureRef<'l, Target: 'l, Closure: Fn() -> &'l Target> {
    closure: Closure,
}

impl<'l, Target: 'l, Closure: Fn() -> &'l Target> ClosureRef<'l, Target, Closure> {
    pub fn new(c: Closure) -> Self {
        Self { closure: c }
    }
}

impl<'l, Target: 'l, Closure: Fn() -> &'l Target> AsRef<Target> for ClosureRef<'l, Target, Closure> {
    fn as_ref(&self) -> &Target {
        (self.closure)()
    }
}

pub struct OwnedRef<'base, Base: 'base, Contained> {
    own: Base,
    get: Box<dyn Fn(&Base) -> &Contained>,
    _ghost: std::marker::PhantomData<&'base ()>,
}

impl<'base, Base, Contained> OwnedRef<'base, Base, Contained> {
    pub fn new<F: 'static + Fn(&Base) -> &Contained>(own: Base, get: F) -> Self {
        Self { own, get: Box::new(get), _ghost: Default::default() }
    }
}

impl<'base, Base, Contained> AsRef<Contained> for OwnedRef<'base, Base, Contained> {
    fn as_ref(&self) -> &Contained {
        (self.get)(&self.own)
    }
}

impl<'base, Base, Contained> std::ops::Deref for OwnedRef<'base, Base, Contained> {
    type Target = Contained;
    fn deref(&self) -> &Self::Target {
        (self.get)(&self.own)
    }
}*/
